/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


#include <generic.h>

#ifdef SVC_CONNECTIONLESS
#undef SVC_REIMPORT
#undef SVC_CLOSE
#define SVC_REIMPORT this->reimport() ;
#define SVC_CLOSE this->close()
#else
#undef SVC_REIMPORT
#undef SVC_CLOSE
#define SVC_REIMPORT 
#define SVC_CLOSE
#endif

/* CALL */

#define generic_call0_0(nproc, sock) \
  SVC_REIMPORT \
  sock << nproc << svcflush ; \
  SVC_CLOSE ;\
  return sock.error() 

#define generic_call1_0(nproc, sock, _p1) \
  SVC_REIMPORT \
  sock << nproc << _p1 << svcflush ; \
  SVC_CLOSE ;\
  return sock.error() 

#define generic_call0_1(nproc, sock, _p1) \
  SVC_REIMPORT \
  sock << nproc << svcflush  ; \
  sock.socket() >> _p1 ; \
  SVC_CLOSE ;\
  return sock.error() 

#define generic_call2_0(nproc, sock, _p1, _p2) \
  SVC_REIMPORT \
  sock << nproc << _p1 << _p2 << svcflush ; \
  SVC_CLOSE ;\
  return sock.error() 

#define generic_call1_1(nproc, sock, _p1, _p2) \
  SVC_REIMPORT \
  sock << nproc << _p1 << svcflush ; \
  sock.socket() >> _p2 ; \
  SVC_CLOSE ;\
  return sock.error() 

#define generic_call0_2(nproc, sock, _p1, _p2) \
  SVC_REIMPORT \
  sock << nproc << svcflush ; \
  sock.socket() >> _p1 >> _p2 ; \
  SVC_CLOSE ;\
  return sock.error() 

#define generic_call3_0(nproc, sock, _p1, _p2, _p3) \
  SVC_REIMPORT \
  sock << nproc << _p1 << _p2 << _p3 << svcflush ; \
  SVC_CLOSE ;\
  return sock.error() 
  
#define generic_call2_1(nproc, sock, _p1, _p2, _p3) \
  SVC_REIMPORT \
  sock << nproc << _p1 << _p2 << svcflush ; \
  sock.socket() >> _p3 ; \
  SVC_CLOSE ;\
  return sock.error() 

#define generic_call1_2(nproc, sock, _p1, _p2, _p3) \
  SVC_REIMPORT \
  sock << nproc << _p1 << svcflush ; \
  sock.socket() >> _p2 >> _p3 ; \
  SVC_CLOSE ;\
  return sock.error() 

#define generic_call0_3(nproc, sock, _p1, _p2, _p3) \
  SVC_REIMPORT \
  sock << nproc << svcflush ; \
  sock.socket() >> _p1 >> _p2 >> _p3; \
  SVC_CLOSE ;\
  return sock.error() 

#define generic_call4_0(nproc, sock, _p1, _p2, _p3, _p4) \
  SVC_REIMPORT \
  sock << nproc << _p1 << _p2 << _p3 << _p4 << svcflush ; \
  SVC_CLOSE ;\
  return sock.error() 

#define generic_call3_1(nproc, sock, _p1, _p2, _p3, _p4) \
  SVC_REIMPORT \
  sock << nproc << _p1 << _p2 << _p3 << svcflush ; \
  sock.socket() >> _p4 ; \
  SVC_CLOSE ;\
  return sock.error() 

#define generic_call2_2(nproc, sock, _p1, _p2, _p3, _p4) \
  SVC_REIMPORT \
  sock << nproc << _p1 << _p2 << svcflush ; \
  sock.socket() >> _p3 >> _p4; \
  SVC_CLOSE ;\
  return sock.error() 

#define generic_call1_3(nproc, sock, _p1, _p2, _p3, _p4) \
  SVC_REIMPORT \
  sock << nproc << _p1 << svcflush ; \
  sock.socket() >> _p2 >> _p3 >> _p4; \
  SVC_CLOSE ;\
  return sock.error() 

#define generic_call0_4(nproc, sock, _p1, _p2, _p3, _p4) \
  SVC_REIMPORT \
  sock << nproc << svcflush ; \
  sock.socket() >> _p1 >> _p2 >> _p3 >> _p4; \
  SVC_CLOSE ;\
  return sock.error() 

#define generic_call5_0(nproc, sock, _p1, _p2, _p3, _p4, _p5) \
  SVC_REIMPORT \
  sock << nproc << _p1 << _p2 << _p3 << _p4 << _p5 << svcflush ; \
  SVC_CLOSE ;\
  return sock.error() 

#define generic_call4_1(nproc, sock, _p1, _p2, _p3, _p4, _p5) \
  SVC_REIMPORT \
  sock << nproc << _p1 << _p2 << _p3 << _p4 << svcflush ; \
  sock.socket() >> _p5 ; \
  SVC_CLOSE ;\
  return sock.error() 

#define generic_call3_2(nproc, sock, _p1, _p2, _p3, _p4, _p5) \
  SVC_REIMPORT \
  sock << nproc << _p1 << _p2 << _p3 << svcflush ; \
  sock.socket() >> _p4 >> _p5 ;; \
  SVC_CLOSE ;\
  return sock.error() 

#define generic_call2_3(nproc, sock, _p1, _p2, _p3, _p4, _p5) \
  SVC_REIMPORT \
  sock << nproc << _p1 << _p2 << svcflush ; \
  sock.socket() >> _p3 >> _p4 >> _p5 ;; \
  SVC_CLOSE ;\
  return sock.error() 

#define generic_call1_4(nproc, sock, _p1, _p2, _p3, _p4, _p5) \
  SVC_REIMPORT \
  sock << nproc << _p1 << svcflush ; \
  sock.socket() >> _p2 >> _p3 >> _p4 >> _p5 ;; \
  SVC_CLOSE ;\
  return sock.error() 

#define generic_call0_5(nproc, sock, _p1, _p2, _p3, _p4, _p5) \
  SVC_REIMPORT \
  sock << nproc << svcflush ; \
  sock.socket() >> _p1 >> _p2 >> _p3 >> _p4 >> _p5 ;; \
  SVC_CLOSE ;\
  return sock.error() 

/* REPLY */


#define generic_reply0_0(s, proc) \
  ((SvcMode(SvcClass)*)(&s))->proc() ; 

#define generic_reply1_0(p1, s, proc) \
  p1 _p1 ; \
  s >> _p1 ; \
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1) ; \

#define generic_reply0_1(p1, s, proc) \
  p1 _p1 ; \
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1) ; \
  s << _p1 << svcflush;

#define generic_reply2_0(p1, p2, s, proc) \
  p1 _p1 ; p2 _p2 ; \
  s >> _p1 >> _p2 ; \
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1, &_p2) ; 

#define generic_reply1_1(p1, p2, s, proc) \
  p1 _p1 ; p2 _p2 ; \
  s >> _p1 ; \
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1, &_p2) ; \
  s << _p2 << svcflush;

#define generic_reply0_2(p1, p2, s, proc) \
  p1 _p1 ; p2 _p2 ; \
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1, &_p2) ; \
  s << _p1 << _p2 << svcflush;

#define generic_reply3_0(p1, p2, p3, s, proc) \
  p1 _p1 ; p2 _p2 ; p3 _p3 ; \
  s >> _p1 >> _p2 >> _p3 ; \
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1, &_p2, &_p3) ; 

#define generic_reply2_1(p1, p2, p3, s, proc) \
  p1 _p1 ; p2 _p2 ; p3 _p3 ; \
  s >> _p1 >> _p2 ; \
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1, &_p2, &_p3) ; \
  s << _p3 << svcflush;

#define generic_reply1_2(p1, p2, p3, s, proc) \
  p1 _p1 ; p2 _p2 ; p3 _p3 ; \
  s >> _p1 ;\
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1, &_p2, &_p3) ; \
  s << _p2 << _p3 << svcflush;

#define generic_reply0_3(p1, p2, p3, s, proc) \
  p1 _p1 ; p2 _p2 ; p3 _p3 ; \
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1, &_p2, &_p3) ; \
  s << _p1 << _p2 << _p3 << svcflush;

#define generic_reply4_0(p1, p2, p3, p4, s, proc) \
  p1 _p1 ; p2 _p2 ; p3 _p3; p4 _p4 ;\
  s >> _p1 >> _p2 >> _p3 >> _p4 ; \
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1, &_p2, &_p3, &_p4) ; 

#define generic_reply3_1(p1, p2, p3, p4, s, proc) \
  p1 _p1 ; p2 _p2 ; p3 _p3; p4 _p4 ;\
  s >> _p1 >> _p2 >> _p3 ; \
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1, &_p2, &_p3, &_p4) ; \
  s << _p4 << svcflush ;

#define generic_reply2_2(p1, p2, p3, p4, s, proc) \
  p1 _p1 ; p2 _p2 ; p3 _p3; p4 _p4 ;\
  s >> _p1 >> _p2 ; \
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1, &_p2, &_p3, &_p4) ; \
  s << _p3 << _p4 << svcflush ;

#define generic_reply1_3(p1, p2, p3, p4, s, proc) \
  p1 _p1 ; p2 _p2 ; p3 _p3; p4 _p4 ;\
  s >> _p1 ; \
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1, &_p2, &_p3, &_p4) ; \
  s << _p2 << _p3 << _p4 << svcflush ;

#define generic_reply0_4(p1, p2, p3, p4, s, proc) \
  p1 _p1 ; p2 _p2 ; p3 _p3; p4 _p4 ;\
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1, &_p2, &_p3, &_p4) ; \
  s << _p1 << _p2 << _p3 << _p4 << svcflush ;

#define generic_reply5_0(p1, p2, p3, p4, p5, s, proc) \
  p1 _p1 ; p2 _p2 ; p3 _p3; p4 _p4 ; p5 _p5 ;\
  s >> _p1 >> _p2 >> _p3 >> _p4 >> _p5 ; \
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1, &_p2, &_p3, &_p4, &_p5) ; 

#define generic_reply4_1(p1, p2, p3, p4, p5, s, proc) \
  p1 _p1 ; p2 _p2 ; p3 _p3; p4 _p4 ; p5 _p5 ;\
  s >> _p1 >> _p2 >> _p3 >> _p4 ; \
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1, &_p2, &_p3, &_p4, &_p5) ; \
  s << _p5 << svcflush ;

#define generic_reply3_2(p1, p2, p3, p4, p5, s, proc) \
  p1 _p1 ; p2 _p2 ; p3 _p3; p4 _p4 ; p5 _p5 ; \
  s >> _p1 >> _p2 >> _p3 ; \
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1, &_p2, &_p3, &_p4, &_p5) ; \
  s << _p4 << _p5 << svcflush ;

#define generic_reply2_3(p1, p2, p3, p4, p5, s, proc) \
  p1 _p1 ; p2 _p2 ; p3 _p3; p4 _p4 ; p5 _p5 ; \
  s >> _p1 >> _p2 ; \
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1, &_p2, &_p3, &_p4, &_p5) ; \
  s << _p3 << _p4 << _p5 << svcflush ;

#define generic_reply1_4(p1, p2, p3, p4, p5, s, proc) \
  p1 _p1 ; p2 _p2 ; p3 _p3; p4 _p4 ; p5 _p5 ; \
  s >> _p1 ; \
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1, &_p2, &_p3, &_p4, &_p5) ; \
  s << _p2 << _p3 << _p4 << _p5 << svcflush ;

#define generic_reply0_5(p1, p2, p3, p4, p5, s, proc) \
  p1 _p1 ; p2 _p2 ; p3 _p3; p4 _p4 ; p5 _p5 ; \
  ((SvcMode(SvcClass)*)(&s))->proc(&_p1, &_p2, &_p3, &_p4, &_p5) ; \
  s << _p1 << _p2 << _p3 << _p4 << _p5 << svcflush ;


#define proxy(x) proxy_##x

#ifdef SVC_CLIENT

#undef SvcLocal
#undef SvcLocalClient
#undef SvcMode
#undef SVC_ROOT
#undef SVC_GENERIC_0
#undef SVC_GENERIC_1
#undef SVC_GENERIC_2
#undef SVC_GENERIC_3
#undef SVC_GENERIC_4
#undef SVC_GENERIC_5

#define SvcLocal(x) 
#define SvcLocalClient(x) x
#define SvcMode(x) name2(proxy_, x)
#define SVC_ROOT SvcClient

#define SVC_GENERIC_0(nbe, nbs, servname) \
  int servname() { \
     int numproc =  SvcMode(InheritSvcClass)::_svc_proc - \
                   _svc_begin - 1 + __LINE__ ; \
     generic_call##nbe##_##nbs(numproc, (*this)) ; \
  }

#define SVC_GENERIC_1(nbe, nbs, servname, p1) \
  int servname(p1& _p1) { \
     int numproc =  SvcMode(InheritSvcClass)::_svc_proc - \
                   _svc_begin - 1 + __LINE__ ; \
     generic_call##nbe##_##nbs(numproc, (*this), _p1) ; \
  }

#define SVC_GENERIC_2(nbe, nbs, servname, p1, p2) \
  int servname(p1& _p1, p2& _p2) { \
     int numproc =  SvcMode(InheritSvcClass)::_svc_proc - \
                   _svc_begin - 1 + __LINE__ ; \
     generic_call##nbe##_##nbs(numproc, (*this), _p1, _p2) ; \
  }

#define SVC_GENERIC_3(nbe, nbs, servname, p1, p2, p3) \
  int servname(p1& _p1, p2& _p2, p3& _p3) { \
     int numproc =  SvcMode(InheritSvcClass)::_svc_proc - \
                   _svc_begin - 1 + __LINE__ ; \
     generic_call##nbe##_##nbs(numproc, (*this), _p1, _p2, _p3) ; \
  }

#define SVC_GENERIC_4(nbe, nbs, servname, p1, p2, p3, p4) \
  int servname(p1& _p1, p2& _p2, p3& _p3, p4& _p4) { \
     int numproc =  SvcMode(InheritSvcClass)::_svc_proc - \
                   _svc_begin - 1 + __LINE__ ; \
     generic_call##nbe##_##nbs(numproc, (*this), _p1, _p2, _p3, _p4) ; \
  }

#define SVC_GENERIC_5(nbe, nbs, servname, p1, p2, p3, p4, p5) \
  int servname(p1& _p1, p2& _p2, p3& _p3, p4& _p4, p5& _p5) { \
     int numproc =  SvcMode(InheritSvcClass)::_svc_proc - \
                   _svc_begin - 1 + __LINE__ ; \
     generic_call##nbe##_##nbs(numproc, (*this), _p1, _p2, _p3, _p4, _p5) ; \
  }

#else

#undef SvcLocal
#undef SvcMode
#undef SvcLocalClient
#undef SVC_ROOT
#undef SVC_GENERIC_0
#undef SVC_GENERIC_1
#undef SVC_GENERIC_2
#undef SVC_GENERIC_3
#undef SVC_GENERIC_4
#undef SVC_GENERIC_5

#define SvcLocal(x) x
#define SvcLocalClient(x) 
#define SvcMode(x) x
#define SVC_ROOT SvcServer

#define SVC_GENERIC_0(nbe, nbs, servname) \
   void servname() ; \
   static void svc_##servname(SvcSocket& s) { \
     generic_reply0_0(s, servname) \
   } ;\
   SvcReqRegister(servname) 

#define SVC_GENERIC_1(nbe, nbs, servname, p1) \
   void servname(p1*) ; \
   static void svc_##servname(SvcSocket& s) { \
     generic_reply##nbe##_##nbs(p1, s, servname) \
   } ;\
   SvcReqRegister(servname) 

#define SVC_GENERIC_2(nbe, nbs, servname, p1, p2) \
   void servname(p1*, p2*) ; \
   static void svc_##servname(SvcSocket& s) { \
     generic_reply##nbe##_##nbs(p1, p2, s, servname) \
   } ;\
   SvcReqRegister(servname) 

#define SVC_GENERIC_3(nbe, nbs, servname, p1, p2, p3) \
   void servname(p1*, p2*, p3*) ; \
   static void svc_##servname(SvcSocket& s) { \
     generic_reply##nbe##_##nbs(p1, p2, p3, s, servname) \
   } ; \
   SvcReqRegister(servname) 

#define SVC_GENERIC_4(nbe, nbs, servname, p1, p2, p3, p4) \
   void servname(p1*, p2*, p3*, p4*) ; \
   static void svc_##servname(SvcSocket& s) { \
     generic_reply##nbe##_##nbs(p1, p2, p3, p4, s, servname) \
   } ; \
   SvcReqRegister(servname) 

#define SVC_GENERIC_5(nbe, nbs, servname, p1, p2, p3, p4, p5) \
   void servname(p1*, p2*, p3*, p4*, p5*) ; \
   static void svc_##servname(SvcSocket& s) { \
     generic_reply##nbe##_##nbs(p1, p2, p3, p4, p5, s, servname) \
   } ; \
   SvcReqRegister(servname) 

#endif

#define SvcStr(x) #x
#define proxy_SvcClient SvcClient
#define SvcBeginClass(x) \
  class SvcMode(SvcClass) : public SvcMode(InheritSvcClass) { \
     public : \
     SvcMode(SvcClass) (int fam=AF_INET) \
        : SvcMode(InheritSvcClass)(SvcStr(x), fam) {} ; \
     SvcMode(SvcClass) (char* n, int f):SvcMode(InheritSvcClass)(n, f) {}; 

//static const u_int _svc_proc ;			      

#define SvcBeginSubClass(x, y) \
  class SvcMode(SvcClass) : public SvcMode(InheritSvcClass), public y { \
     public : \
     SvcMode(SvcClass) (int fam=AF_INET) \
        : SvcMode(InheritSvcClass)(SvcStr(x), fam) {} ; \
     SvcMode(SvcClass) (char* n, int f):SvcMode(InheritSvcClass)(n, f) {}; 

//static const u_int _svc_proc ;			      

#define SvcEndClass \
public : \
  enum { \
    _svc_proc=(SvcMode(InheritSvcClass)::_svc_proc + \
	       SvcMode(SvcClass)::_svc_end-SvcMode(SvcClass)::_svc_begin-1), \
  } ; \
} ; 
							      
#define SvcBeginRemote enum { _svc_begin = __LINE__, } ; 
#define SvcEndRemote enum { _svc_end = __LINE__, } ; 

#define SvcService(pe, ps) SvcService_##pe##_##ps
#define SvcReq(n) req##n


#define SvcReqRegister(servname) \
   class ReqRegister##servname { \
     public : \
     int dummy ; \
     ReqRegister##servname(SvcServer* svc = SvcServer::_svcBase) { \
       int offs = SvcMode(InheritSvcClass)::_svc_proc - \
                   _svc_begin - 1 + __LINE__ ; \
       svc->reqRegister(SvcMode(SvcClass)::svc_##servname, offs) ; \
     } \
   } SvcReq(servname) 


#define SvcService_0_0(servname) \
  SVC_GENERIC_0(0, 0, servname)

#define SvcService_1_0(servname, p1) \
  SVC_GENERIC_1(1, 0, servname, p1)

#define SvcService_0_1(servname, p1) \
  SVC_GENERIC_1(0, 1, servname, p1)

#define SvcService_2_0(servname, p1, p2) \
  SVC_GENERIC_2(2, 0, servname, p1, p2)

#define SvcService_1_1(servname, p1, p2) \
  SVC_GENERIC_2(1, 1, servname, p1, p2)

#define SvcService_0_2(servname, p1, p2) \
  SVC_GENERIC_2(0, 2, servname, p1, p2)

#define SvcService_3_0(servname, p1, p2, p3) \
  SVC_GENERIC_3(3, 0, servname, p1, p2, p3)

#define SvcService_2_1(servname, p1, p2, p3) \
  SVC_GENERIC_3(2, 1, servname, p1, p2, p3)

#define SvcService_1_2(servname, p1, p2, p3) \
  SVC_GENERIC_3(1, 2, servname, p1, p2, p3)

#define SvcService_0_3(servname, p1, p2, p3) \
  SVC_GENERIC_3(0, 3, servname, p1, p2, p3)

#define SvcService_4_0(servname, p1, p2, p3, p4) \
  SVC_GENERIC_4(4, 0, servname, p1, p2, p3, p4)

#define SvcService_3_1(servname, p1, p2, p3, p4) \
  SVC_GENERIC_4(3, 1, servname, p1, p2, p3, p4)

#define SvcService_2_2(servname, p1, p2, p3, p4) \
  SVC_GENERIC_4(2, 2, servname, p1, p2, p3, p4)

#define SvcService_1_3(servname, p1, p2, p3, p4) \
  SVC_GENERIC_4(1, 3, servname, p1, p2, p3, p4)

#define SvcService_0_4(servname, p1, p2, p3, p4) \
  SVC_GENERIC_4(0, 4, servname, p1, p2, p3, p4)

#define SvcService_5_0(servname, p1, p2, p3, p4, p5) \
  SVC_GENERIC_5(5, 0, servname, p1, p2, p3, p4, p5)

#define SvcService_4_1(servname, p1, p2, p3, p4, p5) \
  SVC_GENERIC_5(4, 1, servname, p1, p2, p3, p4, p5)

#define SvcService_3_2(servname, p1, p2, p3, p4, p5) \
  SVC_GENERIC_5(3, 2, servname, p1, p2, p3, p4, p5)

#define SvcService_2_3(servname, p1, p2, p3, p4, p5) \
  SVC_GENERIC_5(2, 3, servname, p1, p2, p3, p4, p5)

#define SvcService_1_4(servname, p1, p2, p3, p4, p5) \
  SVC_GENERIC_5(5, 0, servname, p1, p2, p3, p4, p5)

#define SvcService_0_5(servname, p1, p2, p3, p4, p5) \
  SVC_GENERIC_5(0, 5, servname, p1, p2, p3, p4, p5)

#define SvcEnd \
  enum { _svc_lend = __LINE__, } ; \
} ;  



